"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _SfuExtended_instances, _SfuExtended_connection, _SfuExtended__user, _SfuExtended__server, _SfuExtended__state, _SfuExtended_rooms, _SfuExtended_notifier, _SfuExtended_attachmentState, _SfuExtended_binaryChunkSize, _SfuExtended_logger, _SfuExtended_loggerPrefix, _SfuExtended_signUpId, _SfuExtended_resetPasswordId, _SfuExtended_createConnection, _SfuExtended_emmitAction, _SfuExtended_emmitBinaryAction, _SfuExtended_checkAuthenticated, _SfuExtended_getConnectionConfigForAnonymousUser, _SfuExtended_notifyMessageAttachmentState;
Object.defineProperty(exports, "__esModule", { value: true });
exports.SfuExtended = void 0;
const uuid_1 = require("uuid");
const promises_1 = __importDefault(require("./promises"));
const connection_1 = require("./connection");
const constants_1 = require("./constants");
const notifier_1 = require("./notifier");
const room_extended_1 = require("./room-extended");
const sending_attachments_handler_1 = require("./sending-attachments-handler");
const logger_1 = __importStar(require("./logger"));
const reset_password_handler_1 = require("./reset-password-handler");
class SfuExtended {
    constructor(logLevel, prefix) {
        _SfuExtended_instances.add(this);
        _SfuExtended_connection.set(this, void 0);
        _SfuExtended__user.set(this, void 0);
        _SfuExtended__server.set(this, void 0);
        _SfuExtended__state.set(this, constants_1.State.NEW);
        _SfuExtended_rooms.set(this, {});
        //TODO(naz): Provide union instead of InternalMessage
        _SfuExtended_notifier.set(this, new notifier_1.Notifier());
        _SfuExtended_attachmentState.set(this, []);
        _SfuExtended_binaryChunkSize.set(this, void 0);
        _SfuExtended_logger.set(this, new logger_1.default());
        _SfuExtended_loggerPrefix.set(this, void 0);
        _SfuExtended_signUpId.set(this, '');
        _SfuExtended_resetPasswordId.set(this, '');
        __classPrivateFieldGet(this, _SfuExtended_logger, "f").setVerbosity(logLevel ? logLevel : logger_1.Verbosity.ERROR);
        if (prefix) {
            __classPrivateFieldSet(this, _SfuExtended_loggerPrefix, prefix, "f");
            __classPrivateFieldGet(this, _SfuExtended_logger, "f").setPrefix(prefix);
        }
        __classPrivateFieldGet(this, _SfuExtended_logger, "f").setVerbosity(logLevel ? logLevel : logger_1.Verbosity.ERROR);
    }
    connect(options) {
        if (!options) {
            throw new TypeError("No options provided");
        }
        const connectionConfig = {
            url: options.url,
            appName: constants_1.InternalApi.Z_APP,
            timeout: options.timeout ? options.timeout : 10000,
            failedProbesThreshold: options.failedProbesThreshold,
            pingInterval: options.pingInterval,
            custom: {
                username: options.username,
                password: options.password,
                nickname: options.nickname
            }
        };
        const self = this;
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_createConnection).call(this);
        __classPrivateFieldSet(this, _SfuExtended__server, new URL(options.url).hostname, "f");
        __classPrivateFieldSet(this, _SfuExtended_binaryChunkSize, options.binaryChunkSize ? options.binaryChunkSize : constants_1.ATTACHMENT_CHUNK_SIZE, "f");
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                const userCredentials = yield __classPrivateFieldGet(this, _SfuExtended_connection, "f").connect(connectionConfig);
                __classPrivateFieldSet(self, _SfuExtended__user, {
                    username: userCredentials.sipLogin,
                    email: userCredentials.email,
                    nickname: userCredentials.sipVisibleName,
                    pmi: userCredentials.pmi
                }, "f");
                __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.AUTHENTICATED, "f");
                __classPrivateFieldGet(self, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CONNECTED);
                resolve(__classPrivateFieldGet(self, _SfuExtended__user, "f"));
            }
            catch (e) {
                __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.FAILED, "f");
                __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.FAILED, e);
                reject(e);
            }
        }));
    }
    ;
    signUp(options) {
        const connectionConfig = __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_getConnectionConfigForAnonymousUser).call(this, options.url, options.timeout);
        const self = this;
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            if (__classPrivateFieldGet(self, _SfuExtended_signUpId, "f") && promises_1.default.promised(__classPrivateFieldGet(self, _SfuExtended_signUpId, "f"))) {
                promises_1.default.reject(__classPrivateFieldGet(self, _SfuExtended_signUpId, "f"), new Error(constants_1.UserManagementError.EMAIL_IS_NOT_VERIFIED));
                __classPrivateFieldSet(self, _SfuExtended_signUpId, '', "f");
            }
            if (__classPrivateFieldGet(self, _SfuExtended__state, "f") === constants_1.State.CONNECTED) {
                yield self.disconnect();
            }
            __classPrivateFieldSet(self, _SfuExtended_connection, new connection_1.Connection((name, data) => {
                if (name === constants_1.InternalApi.DEFAULT_METHOD) {
                    if (data[0].type === constants_1.SfuEvent.SIGN_UP_STATUS) {
                        const status = data[0];
                        if (status.verified) {
                            promises_1.default.resolve(data[0].internalMessageId, status);
                            __classPrivateFieldSet(self, _SfuExtended_signUpId, '', "f");
                            self.disconnect();
                            __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.SIGN_UP_STATUS, status);
                        }
                        else {
                            __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.SIGN_UP_STATUS, status);
                        }
                    }
                    else if (data[0].type === constants_1.RoomEvent.OPERATION_FAILED && promises_1.default.promised(data[0].internalMessageId)) {
                        promises_1.default.reject(data[0].internalMessageId, data[0]);
                        __classPrivateFieldSet(self, _SfuExtended_signUpId, '', "f");
                        self.disconnect();
                    }
                }
            }, () => {
            }, (e) => {
                reject(new Error(constants_1.UserManagementError.CONNECTION_ERROR));
                __classPrivateFieldSet(self, _SfuExtended_signUpId, '', "f");
                __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.FAILED, "f");
            }, (e) => {
                if (e.reason === 'Normal disconnect') {
                    promises_1.default.reject(__classPrivateFieldGet(self, _SfuExtended_signUpId, "f"), new Error(constants_1.UserManagementError.OPERATION_FAILED_BY_DISCONNECT));
                    __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.DISCONNECTED, "f");
                    __classPrivateFieldSet(self, _SfuExtended_signUpId, '', "f");
                    self.disconnect();
                }
                else {
                    promises_1.default.reject(__classPrivateFieldGet(self, _SfuExtended_signUpId, "f"), new Error(constants_1.UserManagementError.CONNECTION_FAILED));
                    __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.DISCONNECTED, "f");
                    __classPrivateFieldSet(self, _SfuExtended_signUpId, '', "f");
                    self.disconnect();
                }
            }, __classPrivateFieldGet(this, _SfuExtended_logger, "f")), "f");
            yield __classPrivateFieldGet(self, _SfuExtended_connection, "f").connect(connectionConfig);
            __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.CONNECTED, "f");
            const id = (0, uuid_1.v4)();
            __classPrivateFieldSet(self, _SfuExtended_signUpId, id, "f");
            promises_1.default.add(id, resolve, reject);
            __classPrivateFieldGet(self, _SfuExtended_connection, "f").send(constants_1.InternalApi.SIGN_UP, {
                email: options.email,
                password: options.password,
                internalMessageId: id
            });
        }));
    }
    resetPassword(options) {
        const connectionConfig = __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_getConnectionConfigForAnonymousUser).call(this, options.url, options.timeout);
        const self = this;
        const resetPasswordRequest = () => __awaiter(this, void 0, void 0, function* () {
            return new Promise(function (resolve, reject) {
                const promiseId = (0, uuid_1.v4)();
                __classPrivateFieldSet(self, _SfuExtended_resetPasswordId, promiseId, "f");
                promises_1.default.add(promiseId, resolve, reject);
                __classPrivateFieldGet(self, _SfuExtended_connection, "f").send(constants_1.InternalApi.RESET_PASSWORD_REQUEST, {
                    email: options.email,
                    internalMessageId: promiseId
                });
            });
        });
        const resetPassword = (password) => __awaiter(this, void 0, void 0, function* () {
            return new Promise(function (resolve, reject) {
                const promiseId = (0, uuid_1.v4)();
                __classPrivateFieldSet(self, _SfuExtended_resetPasswordId, promiseId, "f");
                promises_1.default.add(promiseId, resolve, reject);
                __classPrivateFieldGet(self, _SfuExtended_connection, "f").send(constants_1.InternalApi.RESET_PASSWORD, {
                    email: options.email,
                    password: password,
                    internalMessageId: promiseId
                });
            });
        });
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            if (__classPrivateFieldGet(self, _SfuExtended_resetPasswordId, "f") && promises_1.default.promised(__classPrivateFieldGet(self, _SfuExtended_resetPasswordId, "f"))) {
                promises_1.default.reject(__classPrivateFieldGet(self, _SfuExtended_resetPasswordId, "f"), new Error(constants_1.UserManagementError.EMAIL_IS_NOT_VERIFIED));
                __classPrivateFieldSet(self, _SfuExtended_resetPasswordId, '', "f");
            }
            if (__classPrivateFieldGet(self, _SfuExtended__state, "f") === constants_1.State.CONNECTED) {
                yield self.disconnect();
            }
            __classPrivateFieldSet(self, _SfuExtended_connection, new connection_1.Connection((name, data) => {
                if (name === constants_1.InternalApi.DEFAULT_METHOD) {
                    if (data[0].type === constants_1.SfuEvent.RESET_PASSWORD_REQUEST_STATUS) {
                        const status = data[0];
                        if (status.confirmed) {
                            promises_1.default.resolve(data[0].internalMessageId, status);
                            __classPrivateFieldSet(self, _SfuExtended_resetPasswordId, '', "f");
                            __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.RESET_PASSWORD_REQUEST_STATUS, status);
                        }
                        else {
                            __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.RESET_PASSWORD_REQUEST_STATUS, status);
                        }
                    }
                    else if (data[0].type === constants_1.SfuEvent.ACK && promises_1.default.promised(data[0].internalMessageId)) {
                        promises_1.default.resolve(data[0].internalMessageId);
                        __classPrivateFieldSet(self, _SfuExtended_resetPasswordId, '', "f");
                        self.disconnect();
                    }
                    else if (data[0].type === constants_1.RoomEvent.OPERATION_FAILED && promises_1.default.promised(data[0].internalMessageId)) {
                        promises_1.default.reject(data[0].internalMessageId, data[0]);
                        __classPrivateFieldSet(self, _SfuExtended_resetPasswordId, '', "f");
                        self.disconnect();
                    }
                }
            }, () => {
            }, (e) => {
                reject(new Error(constants_1.UserManagementError.CONNECTION_ERROR));
                __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.FAILED, "f");
            }, (e) => {
                if (e.reason === 'Normal disconnect') {
                    promises_1.default.reject(__classPrivateFieldGet(self, _SfuExtended_resetPasswordId, "f"), new Error(constants_1.UserManagementError.OPERATION_FAILED_BY_DISCONNECT));
                    __classPrivateFieldSet(self, _SfuExtended_resetPasswordId, '', "f");
                    __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.DISCONNECTED, "f");
                    self.disconnect();
                }
                else {
                    promises_1.default.reject(__classPrivateFieldGet(self, _SfuExtended_resetPasswordId, "f"), new Error(constants_1.UserManagementError.CONNECTION_FAILED));
                    __classPrivateFieldSet(self, _SfuExtended_resetPasswordId, '', "f");
                    __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.DISCONNECTED, "f");
                    self.disconnect();
                }
            }, __classPrivateFieldGet(this, _SfuExtended_logger, "f")), "f");
            yield __classPrivateFieldGet(self, _SfuExtended_connection, "f").connect(connectionConfig);
            __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.CONNECTED, "f");
            let status;
            try {
                status = yield resetPasswordRequest();
            }
            catch (error) {
                reject(error);
                return;
            }
            if (status.confirmed) {
                resolve(new reset_password_handler_1.ResetPasswordHandler(resetPassword));
            }
        }));
    }
    removeUser(options) {
        const connectionConfig = __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_getConnectionConfigForAnonymousUser).call(this, options.url, options.timeout);
        const self = this;
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            const promiseId = (0, uuid_1.v4)();
            if (__classPrivateFieldGet(self, _SfuExtended__state, "f") === constants_1.State.CONNECTED) {
                yield self.disconnect();
            }
            __classPrivateFieldSet(self, _SfuExtended_connection, new connection_1.Connection((name, data) => {
                if (name === constants_1.InternalApi.DEFAULT_METHOD) {
                    if (data[0].type === constants_1.SfuEvent.ACK && promises_1.default.promised(data[0].internalMessageId)) {
                        promises_1.default.resolve(data[0].internalMessageId);
                    }
                    else if (data[0].type === constants_1.RoomEvent.OPERATION_FAILED && promises_1.default.promised(data[0].internalMessageId)) {
                        promises_1.default.reject(data[0].internalMessageId, data[0]);
                    }
                    self.disconnect();
                }
            }, () => {
            }, (e) => {
                reject(new Error(constants_1.UserManagementError.CONNECTION_ERROR));
                __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.FAILED, "f");
            }, (e) => {
                if (e.reason === 'Normal disconnect') {
                    reject(new Error(constants_1.UserManagementError.OPERATION_FAILED_BY_DISCONNECT));
                    __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.DISCONNECTED, "f");
                    self.disconnect();
                }
                else {
                    reject(new Error(constants_1.UserManagementError.CONNECTION_FAILED));
                    __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.DISCONNECTED, "f");
                    self.disconnect();
                }
            }, __classPrivateFieldGet(this, _SfuExtended_logger, "f")), "f");
            yield __classPrivateFieldGet(self, _SfuExtended_connection, "f").connect(connectionConfig);
            promises_1.default.add(promiseId, resolve, reject);
            __classPrivateFieldGet(self, _SfuExtended_connection, "f").send(constants_1.InternalApi.REMOVE_USER, {
                id: options.id,
                internalMessageId: promiseId
            });
        }));
    }
    ;
    sendMessage(msg) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(self);
            if (!msg) {
                reject(new Error(constants_1.ChatError.CAN_NOT_SEND_NULL_MESSAGE));
            }
            else if ((!msg.body || msg.body === "") && (!msg.attachments || msg.attachments.length === 0)) {
                reject(new Error(constants_1.ChatError.CAN_NOT_SEND_MESSAGE_WITHOUT_CONTENT));
            }
            else if (!msg.chatId || msg.chatId === "") {
                reject(new Error(constants_1.ChatError.CAN_NOT_SEND_MESSAGE_WITHOUT_CHAT_ID));
            }
            else {
                __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.SEND_MESSAGE, {
                    to: msg.to,
                    parentId: msg.parentId,
                    body: msg.body,
                    chatId: msg.chatId,
                    attachments: msg.attachments
                }, resolve, reject);
            }
        });
    }
    ;
    getSendingAttachmentsHandler(attachments, messageId) {
        const self = this;
        const cancelledAttachments = {};
        let promiseForWaitResultMessageStatus;
        let resultMessageStatus;
        let attachmentsIsReady = false;
        function sendMessageWithAttachments(messageId) {
            return new Promise(function (resolve, reject) {
                promises_1.default.add(messageId, resolve, reject);
                __classPrivateFieldGet(self, _SfuExtended_connection, "f").send(constants_1.InternalApi.SEND_MESSAGE_WITH_ATTACHMENTS, {
                    id: messageId
                });
            });
        }
        function cancelSendAttachment(attachmentId) {
            return new Promise(function (resolve, reject) {
                __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.CANCEL_SENDING_ATTACHMENT, {
                    id: attachmentId
                }, resolve, reject);
            });
        }
        function sendAttachmentChunk(data, id, end, index) {
            return new Promise(function (resolve, reject) {
                promises_1.default.add(id.toString(), resolve, reject);
                /**
                 * 3-bytes header:
                 * 1st byte - command (10 - sendMessageAttachment)
                 * 2nd byte - attachment id
                 * 3rd byte - end of attachment
                 * @type {Uint8Array}
                 */
                const header = new Uint8Array([10, id, end]);
                const start = index * __classPrivateFieldGet(self, _SfuExtended_binaryChunkSize, "f");
                const chunk = new Blob([header, data.slice(start, start + __classPrivateFieldGet(self, _SfuExtended_binaryChunkSize, "f"))]);
                __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitBinaryAction).call(self, chunk);
            });
        }
        function uploadAttachment(attachment) {
            return __awaiter(this, void 0, void 0, function* () {
                return new Promise(function (resolve, reject) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const id = attachment.id;
                        const { payload } = attachment;
                        const data = new Blob([payload]);
                        const chunks = Math.ceil(data.size / __classPrivateFieldGet(self, _SfuExtended_binaryChunkSize, "f"));
                        for (let i = 0; i < chunks; i++) {
                            let end = 0;
                            if (i === chunks - 1) {
                                end = 1;
                            }
                            const cancellationPromise = cancelledAttachments[id];
                            if (cancellationPromise === undefined) {
                                const result = yield sendAttachmentChunk(data, id, end, i);
                                const attachmentState = result;
                                if (attachmentState.state === constants_1.AttachmentState.UPLOADED) {
                                    resolve(attachmentState);
                                }
                            }
                            else {
                                delete cancelledAttachments[id];
                                resolve(cancellationPromise.status);
                                break;
                            }
                        }
                    });
                });
            });
        }
        function sendAttachments() {
            return {
                send: () => new Promise(function (resolve, reject) {
                    return __awaiter(this, void 0, void 0, function* () {
                        __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(self);
                        if (attachments.length) {
                            for (let i = 0; i < attachments.length; i++) {
                                const attachmentId = attachments[i].id;
                                const cancellationPromise = cancelledAttachments[attachmentId];
                                if (cancellationPromise === undefined) {
                                    yield uploadAttachment(attachments[i]);
                                }
                                else {
                                    delete cancelledAttachments[attachmentId];
                                }
                            }
                            attachmentsIsReady = true;
                            const result = yield sendMessageWithAttachments(messageId);
                            if (promiseForWaitResultMessageStatus) {
                                promiseForWaitResultMessageStatus.resolve(result);
                            }
                            resultMessageStatus = result;
                            resolve(result);
                        }
                        else {
                            reject(new Error("No attachments"));
                        }
                    });
                }),
                cancel: (attachment) => new Promise(function (resolve, reject) {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (!attachmentsIsReady) {
                            const result = yield cancelSendAttachment(attachment.id);
                            if (result.uploadedSize !== attachment.size) {
                                cancelledAttachments[attachment.id] = { status: result };
                            }
                            resolve(result);
                        }
                        else {
                            reject(new Error(constants_1.ChatError.CAN_NOT_CANCEL_SENDING_ATTACHMENT));
                        }
                    });
                }),
                waitAndGetMessageStatus: () => new Promise(function (resolve, reject) {
                    if (resultMessageStatus) {
                        resolve(resultMessageStatus);
                    }
                    else {
                        promiseForWaitResultMessageStatus = { resolve, reject };
                    }
                }),
                getAttachmentsData: () => {
                    return attachments;
                }
            };
        }
        return new sending_attachments_handler_1.SendingAttachmentsHandler(sendAttachments());
    }
    getMessageAttachment(attachment) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        const { attachmentId, name, messageId, chatId } = attachment;
        if (!messageId || messageId === '') {
            throw new Error('Empty messageId');
        }
        if (!chatId || chatId === '') {
            throw new Error('Empty chatId');
        }
        if (!name || name === '') {
            throw new Error('Empty attachment name');
        }
        if (attachmentId === null) {
            throw new Error('Empty attachment id');
        }
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.GET_ATTACHMENT, {
                messageId: messageId,
                chatId: chatId,
                attachmentId: attachmentId,
                name: name,
                size: __classPrivateFieldGet(self, _SfuExtended_binaryChunkSize, "f")
            }, resolve, reject);
        });
    }
    markMessageRead(msg) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            if (!msg) {
                reject(new Error("Can't mark null message"));
            }
            else if (!msg.chatId || msg.chatId === "") {
                reject(new Error("Can't mark message without a chatId"));
            }
            else if (!msg.id || msg.id === "") {
                reject(new Error("Can't mark message without massage id"));
            }
            else {
                __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.MARK_MESSAGE_READ, {
                    id: msg.id,
                    chatId: msg.chatId
                }, resolve, reject);
            }
        });
    }
    markMessageUnread(msg) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            if (!msg) {
                reject(new Error("Can't mark null message"));
            }
            else if (!msg.chatId || msg.chatId === "") {
                reject(new Error("Can't mark message without a chatId"));
            }
            else if (!msg.id || msg.id === "") {
                reject(new Error("Can't mark message without massage id"));
            }
            else {
                __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.MARK_MESSAGE_UNREAD, {
                    id: msg.id,
                    chatId: msg.chatId
                }, resolve, reject);
            }
        });
    }
    getUserList() {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.GET_USER_LIST, {}, resolve, reject);
        });
    }
    ;
    getUserCalendar() {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.GET_USER_CALENDAR, {}, resolve, reject);
        });
    }
    ;
    getUserPmiSettings() {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.GET_USER_PMI_SETTINGS, {}, resolve, reject);
        });
    }
    updateUserPmiSettings(settings) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.UPDATE_USER_PMI_SETTINGS, Object.assign({}, settings), resolve, reject);
        });
    }
    getUserInfo() {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.GET_USER_INFO, {}, resolve, reject);
        });
    }
    changeUserEmail(email) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.CHANGE_USER_EMAIL, {
                email: email
            }, resolve, reject);
        });
    }
    ;
    changeUserPassword(currentPassword, newPassword) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.CHANGE_USER_PASSWORD, {
                password: {
                    currentPassword: currentPassword,
                    newPassword: newPassword
                }
            }, resolve, reject);
        });
    }
    ;
    changeUserNickname(nickname) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.CHANGE_USER_NICKNAME, {
                nickname: nickname
            }, resolve, reject);
        });
    }
    ;
    changeUserPhoneNumber(phoneNumber) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.CHANGE_USER_PHONE_NUMBER, {
                phoneNumber: phoneNumber
            }, resolve, reject);
        });
    }
    ;
    changeUserHostKey(hostKey) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.CHANGE_USER_HOST_KEY, {
                hostKey: hostKey
            }, resolve, reject);
        });
    }
    ;
    changeUserTimezone(timezone) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.CHANGE_USER_TIMEZONE, {
                timezone: timezone
            }, resolve, reject);
        });
    }
    ;
    addCalendarEvent(event) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.ADD_CALENDAR_EVENT, {
                event: event
            }, resolve, reject);
        });
    }
    ;
    removeCalendarEvent(event) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.REMOVE_CALENDAR_EVENT, {
                event: event
            }, resolve, reject);
        });
    }
    ;
    updateCalendarEvent(event) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.UPDATE_CALENDAR_EVENT, {
                event: event
            }, resolve, reject);
        });
    }
    getUserChats() {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.GET_USER_CHATS, {}, resolve, reject);
        });
    }
    ;
    getPublicChannels() {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.GET_PUBLIC_CHANNELS, {}, resolve, reject);
        });
    }
    ;
    loadChat(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.LOAD_CHAT, { id: chat.id }, resolve, reject);
        });
    }
    ;
    loadChatMessages(params) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.LOAD_CHAT_MESSAGES, params, resolve, reject);
        });
    }
    ;
    searchChatMessages(params) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.SEARCH_CHAT_MESSAGES, params, resolve, reject);
        });
    }
    ;
    getChatMessagesCount(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.GET_CHAT_MESSAGES_COUNT, {
                chatId: chat.id
            }, resolve, reject);
        });
    }
    searchMessageAttachments(params) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.SEARCH_MESSAGE_ATTACHMENTS, {
                chatId: params.chatId,
                attachmentsType: params.attachmentsType,
                bookmarkedOnly: params.bookmarkedOnly,
                from: params.from,
                timeFrame: params.timeFrame,
                boundaries: params.boundaries,
                searchString: params.searchString,
                sortOrder: params.sortOrder,
            }, resolve, reject);
        });
    }
    ;
    loadBookmarkedMessages(params) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.LOAD_BOOKMARKED_MESSAGES, {
                chatId: params.chatId,
                timeFrame: params.timeFrame,
                boundaries: params.boundaries,
                sortOrder: params.sortOrder,
            }, resolve, reject);
        });
    }
    ;
    loadMessagesWithMentions(params) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.LOAD_MESSAGES_WITH_MENTIONS, {
                chatId: params.chatId,
                userTag: params.userTag,
                timeFrame: params.timeFrame,
                boundaries: params.boundaries,
                sortOrder: params.sortOrder,
            }, resolve, reject);
        });
    }
    ;
    createChat(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.CREATE_CHAT, {
                id: chat.id,
                name: chat.name,
                members: chat.members,
                favourite: chat.favourite,
                channel: chat.channel,
                channelType: chat.channelType,
                channelSendPolicy: chat.channelSendPolicy,
                sendPermissionList: chat.sendPermissionList,
                allowedToAddExternalUser: chat.allowedToAddExternalUser
            }, resolve, reject);
        });
    }
    ;
    deleteChat(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.DELETE_CHAT, { id: chat.id }, resolve, reject);
        });
    }
    ;
    renameChat(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.RENAME_CHAT, { id: chat.id, name: chat.name }, resolve, reject);
        });
    }
    ;
    editChatMessage(msg) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.EDIT_CHAT_MESSAGE, {
                id: msg.messageId,
                chatId: msg.chatId,
                body: msg.body,
                attachments: msg.attachmentsToSend,
                attachmentIdsToDelete: msg.attachmentIdsToDelete
            }, resolve, reject);
        });
    }
    deleteChatMessage(msg) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.DELETE_CHAT_MESSAGE, {
                id: msg.messageId,
                chatId: msg.chatId,
            }, resolve, reject);
        });
    }
    addMessageToBookmarks(msg) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.ADD_MESSAGE_TO_BOOKMARKS, {
                id: msg.messageId,
                chatId: msg.chatId
            }, resolve, reject);
        });
    }
    removeMessageFromBookmarks(msg) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.REMOVE_MESSAGE_FROM_BOOKMARKS, {
                chatId: msg.chatId,
                id: msg.messageId
            }, resolve, reject);
        });
    }
    addMemberToChat(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.ADD_MEMBER_TO_CHAT, { id: chat.id, member: chat.member }, resolve, reject);
        });
    }
    ;
    removeMemberFromChat(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.REMOVE_MEMBER_FROM_CHAT, { id: chat.id, member: chat.member }, resolve, reject);
        });
    }
    ;
    inviteContact(invite) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.INVITE_CONTACT, { from: __classPrivateFieldGet(self, _SfuExtended__user, "f").username, to: invite.to }, resolve, reject);
        });
    }
    addContactToFavourites(contact) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.ADD_CONTACT_TO_FAVOURITES, { id: contact.id }, resolve, reject);
        });
    }
    removeContactFromFavourites(contact) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.REMOVE_CONTACT_FROM_FAVOURITES, { id: contact.id }, resolve, reject);
        });
    }
    confirmContact(invite) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.CONFIRM_CONTACT, {
                from: invite.from,
                to: invite.to,
                id: invite.id
            }, resolve, reject);
        });
    }
    removeContact(contact) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.REMOVE_CONTACT, { id: contact.id }, resolve, reject);
        });
    }
    updateChannelSendPolicy(channel) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.UPDATE_CHANNEL_SEND_POLICY, {
                id: channel.id,
                channelSendPolicy: channel.channelSendPolicy
            }, resolve, reject);
        });
    }
    updateChatReceivePolicy(channel) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.UPDATE_CHAT_RECEIVE_POLICY, {
                id: channel.id,
                chatReceivePolicy: channel.chatReceivePolicy
            }, resolve, reject);
        });
    }
    addChannelSendPermissionListMember(channel) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.ADD_CHANNEL_SEND_PERMISSION_LIST_MEMBER, {
                id: channel.id,
                member: channel.member
            }, resolve, reject);
        });
    }
    removeChannelSendPermissionListMember(channel) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.REMOVE_CHANNEL_SEND_PERMISSION_LIST_MEMBER, {
                id: channel.id,
                member: channel.member
            }, resolve, reject);
        });
    }
    updateChatConfiguration(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.UPDATE_CHAT_CONFIGURATION, chat, resolve, reject);
        });
    }
    addChatToFavourites(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.ADD_CHAT_TO_FAVOURITES, { id: chat.id }, resolve, reject);
        });
    }
    removeChatFromFavourites(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.REMOVE_CHAT_FROM_FAVOURITES, { id: chat.id }, resolve, reject);
        });
    }
    createRoom(options) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise((resolve, reject) => {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.CREATE_ROOM, {
                id: options.id,
                name: options.name,
                pin: options.pin
            }, resolve, reject);
        });
    }
    ;
    createRoomFromEvent(event) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise((resolve, reject) => {
            __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(this, constants_1.InternalApi.CREATE_ROOM_FROM_EVENT, {
                event: event
            }, resolve, reject);
        });
    }
    loadActiveRooms() {
        const self = this;
        return new Promise((resolve, reject) => {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.GET_ACTIVE_ROOMS, {}, resolve, reject);
        });
    }
    roomAvailable(options) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise((resolve, reject) => {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.ROOM_AVAILABLE, {
                id: options.id,
                pin: options.pin
            }, resolve, reject);
        });
    }
    ;
    roomExists(options) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise((resolve, reject) => {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.ROOM_EXISTS, {
                id: options.id,
                pin: options.pin
            }, resolve, reject);
        });
    }
    ;
    getRoom(options) {
        if (!options) {
            throw new TypeError("No options provided");
        }
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        return __classPrivateFieldGet(this, _SfuExtended_rooms, "f")[options.id];
    }
    disconnect() {
        return __awaiter(this, void 0, void 0, function* () {
            for (const [key, value] of Object.entries(__classPrivateFieldGet(this, _SfuExtended_rooms, "f"))) {
                value.leaveRoom();
            }
            __classPrivateFieldSet(this, _SfuExtended__user, undefined, "f");
            if (__classPrivateFieldGet(this, _SfuExtended__state, "f") !== constants_1.State.DISCONNECTED) {
                yield __classPrivateFieldGet(this, _SfuExtended_connection, "f").close();
                __classPrivateFieldSet(this, _SfuExtended__state, constants_1.State.DISCONNECTED, "f");
            }
            __classPrivateFieldSet(this, _SfuExtended_rooms, {}, "f");
        });
    }
    ;
    user() {
        return __classPrivateFieldGet(this, _SfuExtended__user, "f");
    }
    server() {
        return __classPrivateFieldGet(this, _SfuExtended__server, "f");
    }
    state() {
        return __classPrivateFieldGet(this, _SfuExtended__state, "f");
    }
    on(event, callback) {
        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").add(event, callback);
        return this;
    }
    ;
    off(event, callback) {
        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").remove(event, callback);
        return this;
    }
    ;
    closePcAndFireEvent(room) {
        if (__classPrivateFieldGet(this, _SfuExtended_rooms, "f")[room.id()].pc()) {
            __classPrivateFieldGet(this, _SfuExtended_rooms, "f")[room.id()].pc().close();
            // zapp-28, react-native-webrtc will fire 'connectionstatechange' event
            if (typeof document !== 'undefined') {
                __classPrivateFieldGet(this, _SfuExtended_rooms, "f")[room.id()].pc().dispatchEvent(new Event("connectionstatechange"));
            }
        }
    }
}
exports.SfuExtended = SfuExtended;
_SfuExtended_connection = new WeakMap(), _SfuExtended__user = new WeakMap(), _SfuExtended__server = new WeakMap(), _SfuExtended__state = new WeakMap(), _SfuExtended_rooms = new WeakMap(), _SfuExtended_notifier = new WeakMap(), _SfuExtended_attachmentState = new WeakMap(), _SfuExtended_binaryChunkSize = new WeakMap(), _SfuExtended_logger = new WeakMap(), _SfuExtended_loggerPrefix = new WeakMap(), _SfuExtended_signUpId = new WeakMap(), _SfuExtended_resetPasswordId = new WeakMap(), _SfuExtended_instances = new WeakSet(), _SfuExtended_createConnection = function _SfuExtended_createConnection() {
    const self = this;
    __classPrivateFieldSet(this, _SfuExtended_connection, new connection_1.Connection((name, data) => {
        __classPrivateFieldGet(this, _SfuExtended_logger, "f").debug("onMessage: ", data[0]);
        switch (name) {
            case constants_1.InternalApi.DEFAULT_METHOD:
                //filter messages
                //TODO(naz): refactor this part
                if (data[0].type === constants_1.InternalApi.MESSAGE) {
                    const message = data[0].message;
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.MESSAGE, message);
                }
                else if (data[0].type === constants_1.InternalApi.MESSAGE_STATE) {
                    const messageState = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, messageState.status)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.MESSAGE_STATE, messageState.status);
                    }
                }
                else if (data[0].type === constants_1.InternalApi.MESSAGE_ATTACHMENT_STATE) {
                    const attachmentState = data[0];
                    promises_1.default.resolve(data[0].internalMessageId, attachmentState.status);
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.MESSAGE_ATTACHMENT_STATE, attachmentState.status);
                }
                else if (data[0].type === constants_1.InternalApi.MESSAGE_STATE_BULK) {
                    const messageState = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, messageState)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.MESSAGE_STATE_BULK, messageState);
                    }
                }
                else if (data[0].type === constants_1.InternalApi.SFU_ATTACHMENT_REQUEST_ACK) {
                    const ack = data[0];
                    const request = ack.attachmentRequest;
                    const state = __classPrivateFieldGet(this, _SfuExtended_attachmentState, "f").find(s => s.messageId === ack.attachmentRequest.messageId);
                    if (!state) {
                        __classPrivateFieldGet(this, _SfuExtended_attachmentState, "f").push(Object.assign(Object.assign({}, request), { payload: null, internalMessageId: ack.internalMessageId }));
                    }
                }
                else if (data[0].type === constants_1.InternalApi.USER_LIST) {
                    const userList = data[0];
                    promises_1.default.resolve(data[0].internalMessageId, userList.list);
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.USER_LIST, userList.list);
                }
                else if (data[0].type === constants_1.InternalApi.USER_CALENDAR) {
                    const calendar = data[0];
                    promises_1.default.resolve(data[0].internalMessageId, calendar.calendar);
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.USER_CALENDAR, calendar.calendar);
                }
                else if (data[0].type === constants_1.SfuEvent.NEW_CALENDAR_ENTRY) {
                    const calendarEntry = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, calendarEntry.entry)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.NEW_CALENDAR_ENTRY, calendarEntry.entry);
                    }
                }
                else if (data[0].type === constants_1.SfuEvent.REMOVE_CALENDAR_ENTRY) {
                    const calendarEntry = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, calendarEntry.entry)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.REMOVE_CALENDAR_ENTRY, calendarEntry.entry);
                    }
                }
                else if (data[0].type === constants_1.SfuEvent.UPDATE_CALENDAR_EVENT) {
                    const calendarEntry = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, calendarEntry.entry)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.UPDATE_CALENDAR_EVENT, calendarEntry.entry);
                    }
                }
                else if (data[0].type === constants_1.SfuEvent.SFU_USER_PMI_SETTINGS) {
                    const pmiSettings = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, pmiSettings)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.SFU_USER_PMI_SETTINGS, pmiSettings);
                    }
                }
                else if (data[0].type === constants_1.SfuEvent.UPDATE_USER_PMI_SETTINGS) {
                    const pmiSettings = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, pmiSettings)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.UPDATE_USER_PMI_SETTINGS, pmiSettings);
                    }
                }
                else if (data[0].type === constants_1.InternalApi.NEW_CHAT) {
                    const chatInfo = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, chatInfo.info)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.NEW_CHAT, chatInfo.info);
                    }
                }
                else if (data[0].type === constants_1.InternalApi.CONTACT_INVITE) {
                    const invite = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, invite.invite)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CONTACT_INVITE, invite.invite);
                    }
                }
                else if (data[0].type === constants_1.InternalApi.CONTACT_UPDATED) {
                    const contact = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, contact.contact)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CONTACT_UPDATE, contact.contact);
                    }
                }
                else if (data[0].type === constants_1.InternalApi.CONTACT_REMOVED) {
                    const contact = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, contact.contact)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CONTACT_REMOVED, contact.contact);
                    }
                }
                else if (data[0].type === constants_1.InternalApi.CHAT_DELETED) {
                    const chat = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, chat.info)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CHAT_DELETED, chat.info);
                    }
                }
                else if (data[0].type === constants_1.InternalApi.CHAT_UPDATED) {
                    const chat = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, chat.info)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CHAT_UPDATED, chat.info);
                    }
                }
                else if (data[0].type === constants_1.InternalApi.USER_CHATS) {
                    //TODO: optimize - should use with if (zapp-420)
                    const chats = data[0];
                    promises_1.default.resolve(data[0].internalMessageId, chats.chats);
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.USER_CHATS, chats.chats);
                }
                else if (data[0].type === constants_1.InternalApi.PUBLIC_CHANNELS) {
                    const channels = data[0];
                    promises_1.default.resolve(data[0].internalMessageId, channels.channels);
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.PUBLIC_CHANNELS, channels.channels);
                }
                else if (data[0].type === constants_1.InternalApi.CHAT_LOADED) {
                    const chat = data[0];
                    promises_1.default.resolve(data[0].internalMessageId, chat.chat);
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CHAT_LOADED, chat.chat);
                }
                else if (data[0].type === constants_1.SfuEvent.CHAT_MESSAGES) {
                    const messagesEvent = data[0];
                    promises_1.default.resolve(data[0].internalMessageId, messagesEvent.messages);
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CHAT_MESSAGES, messagesEvent);
                }
                else if (data[0].type === constants_1.SfuEvent.CHAT_SEARCH_RESULT) {
                    const messagesEvent = data[0];
                    promises_1.default.resolve(data[0].internalMessageId, messagesEvent.messages);
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CHAT_SEARCH_RESULT, messagesEvent);
                }
                else if (data[0].type === constants_1.RoomEvent.CREATED) {
                    const state = data[0];
                    const room = new room_extended_1.RoomExtended(__classPrivateFieldGet(this, _SfuExtended_connection, "f"), state.roomId, state.owner, state.name, state.pin, this.user().nickname, state.creationTime, state.config, state.waitingRoomEnabled, __classPrivateFieldGet(this, _SfuExtended_loggerPrefix, "f"));
                    __classPrivateFieldGet(this, _SfuExtended_rooms, "f")[room.id()] = room;
                    const self = this;
                    const cleanup = () => {
                        self.closePcAndFireEvent(room);
                        delete __classPrivateFieldGet(self, _SfuExtended_rooms, "f")[room.id()];
                    };
                    room.on(constants_1.RoomEvent.LEFT, function (participant) {
                        if (participant.name === room.nickname()) {
                            cleanup();
                        }
                    }).on(constants_1.RoomEvent.EVICTED, function (participant) {
                        if (participant.name === room.nickname()) {
                            cleanup();
                        }
                    }).on(constants_1.RoomEvent.DROPPED, function (participant) {
                        if (participant.name === room.nickname()) {
                            cleanup();
                        }
                    }).on(constants_1.RoomEvent.ENDED, cleanup).on(constants_1.RoomEvent.FAILED, cleanup).on(constants_1.RoomEvent.OPERATION_FAILED, function (e) {
                        if (constants_1.Operations.ROOM_JOIN === e.operation) {
                            cleanup();
                        }
                    });
                    promises_1.default.resolve(data[0].internalMessageId, room);
                }
                else if (data[0].type === constants_1.RoomEvent.AVAILABLE) {
                    const state = data[0];
                    const room = new room_extended_1.RoomExtended(__classPrivateFieldGet(this, _SfuExtended_connection, "f"), state.roomId, state.owner, state.name, state.pin, this.user().nickname, state.creationTime, state.config, state.waitingRoomEnabled, __classPrivateFieldGet(this, _SfuExtended_loggerPrefix, "f"));
                    __classPrivateFieldGet(this, _SfuExtended_rooms, "f")[room.id()] = room;
                    const self = this;
                    const cleanup = () => {
                        self.closePcAndFireEvent(room);
                        delete __classPrivateFieldGet(self, _SfuExtended_rooms, "f")[room.id()];
                    };
                    room.on(constants_1.RoomEvent.LEFT, function (participant) {
                        if (participant.name === room.nickname()) {
                            cleanup();
                        }
                    }).on(constants_1.RoomEvent.EVICTED, function (participant) {
                        if (participant.name === room.nickname()) {
                            cleanup();
                        }
                    }).on(constants_1.RoomEvent.DROPPED, function (participant) {
                        if (participant.name === room.nickname()) {
                            cleanup();
                        }
                    }).on(constants_1.RoomEvent.ENDED, cleanup).on(constants_1.RoomEvent.FAILED, cleanup).on(constants_1.RoomEvent.OPERATION_FAILED, function (e) {
                        if (constants_1.Operations.ROOM_JOIN === e.operation) {
                            cleanup();
                        }
                    });
                    promises_1.default.resolve(data[0].internalMessageId, room);
                }
                else if (data[0].type === constants_1.SfuEvent.USER_ROOMS) {
                    const state = data[0];
                    state.rooms.forEach((info) => {
                        const room = new room_extended_1.RoomExtended(__classPrivateFieldGet(this, _SfuExtended_connection, "f"), info.id, info.owner, info.name, info.pin, this.user().nickname, info.creationTime, info.config, info.waitingRoomEnabled, __classPrivateFieldGet(this, _SfuExtended_loggerPrefix, "f"));
                        __classPrivateFieldGet(this, _SfuExtended_rooms, "f")[room.id()] = room;
                        const self = this;
                        const cleanup = () => {
                            self.closePcAndFireEvent(room);
                            delete __classPrivateFieldGet(self, _SfuExtended_rooms, "f")[room.id()];
                        };
                        room.on(constants_1.RoomEvent.LEFT, function (participant) {
                            if (participant.name === room.nickname()) {
                                cleanup();
                            }
                        }).on(constants_1.RoomEvent.EVICTED, function (participant) {
                            if (participant.name === room.nickname()) {
                                cleanup();
                            }
                        }).on(constants_1.RoomEvent.DROPPED, function (participant) {
                            if (participant.name === room.nickname()) {
                                cleanup();
                            }
                        }).on(constants_1.RoomEvent.ENDED, cleanup).on(constants_1.RoomEvent.FAILED, cleanup).on(constants_1.RoomEvent.OPERATION_FAILED, function (e) {
                            if (constants_1.Operations.ROOM_JOIN === e.operation) {
                                cleanup();
                            }
                        });
                    });
                    promises_1.default.resolve(data[0].internalMessageId, state.rooms);
                }
                else if (data[0].type === constants_1.RoomEvent.OPERATION_FAILED && promises_1.default.promised(data[0].internalMessageId)) {
                    promises_1.default.reject(data[0].internalMessageId, data[0]);
                    if (data[0].roomId && data[0].roomId.length > 0) {
                        //hand over to processEvent where the OperationTypeEvent handled for a room
                        const room = __classPrivateFieldGet(this, _SfuExtended_rooms, "f")[data[0].roomId];
                        if (room) {
                            room.processEvent(data[0]);
                        }
                    }
                }
                else if (data[0].type === constants_1.SfuEvent.ACK && promises_1.default.promised(data[0].internalMessageId)) {
                    promises_1.default.resolve(data[0].internalMessageId);
                }
                else if (data[0].roomId && data[0].roomId.length > 0) {
                    //room event
                    const room = __classPrivateFieldGet(this, _SfuExtended_rooms, "f")[data[0].roomId];
                    if (room) {
                        room.processEvent(data[0]);
                    }
                }
                else if (data[0].type === constants_1.SfuEvent.USER_INFO) {
                    const event = data[0];
                    promises_1.default.resolve(event.internalMessageId, event.userInfo);
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.USER_INFO, event.userInfo);
                }
                else if (data[0].type === constants_1.SfuEvent.USER_EMAIL_CHANGED) {
                    const event = data[0];
                    if (promises_1.default.resolve(event.internalMessageId)) {
                        __classPrivateFieldGet(this, _SfuExtended__user, "f").email = event.email;
                    }
                }
                else if (data[0].type === constants_1.SfuEvent.USER_NICKNAME_CHANGED) {
                    const event = data[0];
                    if (promises_1.default.resolve(event.internalMessageId)) {
                        __classPrivateFieldGet(this, _SfuExtended__user, "f").nickname = event.nickname;
                    }
                }
                else if (data[0].type === constants_1.SfuEvent.CHAT_MESSAGE_EDITED) {
                    const message = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, message)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CHAT_MESSAGE_EDITED, message);
                    }
                }
                else if (data[0].type === constants_1.SfuEvent.CHAT_MESSAGE_DELETED) {
                    const message = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, message)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CHAT_MESSAGE_DELETED, message);
                    }
                }
                else if (data[0].type === constants_1.SfuEvent.CHAT_MESSAGES_COUNT) {
                    const messagesCount = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, messagesCount)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CHAT_MESSAGES_COUNT, messagesCount);
                    }
                }
                else if (data[0].type === constants_1.SfuEvent.MESSAGE_ATTACHMENTS_SEARCH_RESULT) {
                    const result = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, result)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.MESSAGE_ATTACHMENTS_SEARCH_RESULT, result);
                    }
                }
                else if (data[0].type === constants_1.SfuEvent.LOAD_BOOKMARKED_MESSAGES_RESULT) {
                    const result = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, result)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.LOAD_BOOKMARKED_MESSAGES_RESULT, result);
                    }
                }
                else if (data[0].type === constants_1.SfuEvent.LOAD_MESSAGES_WITH_MENTIONS_RESULT) {
                    const result = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, result)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.LOAD_MESSAGES_WITH_MENTIONS_RESULT, result);
                    }
                }
                else {
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(data[0].type, data[0]);
                }
                break;
            case "failed":
                __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.FAILED, data[0]);
                break;
        }
    }, (name, data) => {
        switch (name) {
            case constants_1.InternalApi.BINARY_DATA:
                const buffer = new Uint8Array(data);
                const id = buffer[1];
                const eof = buffer[2];
                const attachment = __classPrivateFieldGet(this, _SfuExtended_attachmentState, "f").find(attachment => attachment.tmpId === id);
                if (attachment) {
                    if (!attachment.payload) {
                        attachment.payload = data.slice(3, data.byteLength);
                    }
                    else {
                        //ToDo (igor): optimize ArrayBuffer merging
                        const newData = new Uint8Array(attachment.payload.byteLength + (data.byteLength - 3));
                        newData.set(new Uint8Array(attachment.payload), 0);
                        newData.set(new Uint8Array(data.slice(3, data.byteLength)), attachment.payload.byteLength);
                        attachment.payload = newData.buffer;
                    }
                    if (eof === 1) {
                        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_notifyMessageAttachmentState).call(this, attachment, constants_1.AttachmentState.DOWNLOADED);
                        const index = __classPrivateFieldGet(this, _SfuExtended_attachmentState, "f").indexOf(attachment);
                        __classPrivateFieldGet(this, _SfuExtended_attachmentState, "f").splice(index, 1);
                        // ToDo (igor): need to resolve or reject in any case
                        promises_1.default.resolve(attachment.internalMessageId, attachment);
                    }
                    else {
                        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_notifyMessageAttachmentState).call(this, attachment, constants_1.AttachmentState.PENDING);
                    }
                }
                else {
                    __classPrivateFieldGet(this, _SfuExtended_logger, "f").info("Unable to find attachment " + id);
                }
                break;
            default:
                console.error("Unknown binary data type " + name);
        }
    }, (e) => {
        __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.FAILED, "f");
        __classPrivateFieldGet(self, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CONNECTION_FAILED, e);
    }, (e) => {
        __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.DISCONNECTED, "f");
        self.disconnect();
        __classPrivateFieldGet(self, _SfuExtended_attachmentState, "f").length = 0;
        if (e.reason === 'Normal disconnect') {
            __classPrivateFieldGet(self, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.DISCONNECTED, e);
        }
        else {
            __classPrivateFieldGet(self, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CONNECTION_FAILED, e);
        }
    }, __classPrivateFieldGet(this, _SfuExtended_logger, "f")), "f");
}, _SfuExtended_emmitAction = function _SfuExtended_emmitAction(action, data, resolve, reject) {
    const id = (0, uuid_1.v4)();
    promises_1.default.add(id, resolve, reject);
    __classPrivateFieldGet(this, _SfuExtended_connection, "f").send(action, Object.assign(Object.assign({}, data), { internalMessageId: id }));
}, _SfuExtended_emmitBinaryAction = function _SfuExtended_emmitBinaryAction(data) {
    __classPrivateFieldGet(this, _SfuExtended_connection, "f").sendBinaryData(data);
}, _SfuExtended_checkAuthenticated = function _SfuExtended_checkAuthenticated() {
    if (__classPrivateFieldGet(this, _SfuExtended__state, "f") !== constants_1.State.AUTHENTICATED) {
        throw new Error("User isn't authenticated, current state " + __classPrivateFieldGet(this, _SfuExtended__state, "f"));
    }
}, _SfuExtended_getConnectionConfigForAnonymousUser = function _SfuExtended_getConnectionConfigForAnonymousUser(url, timeout) {
    return {
        url: url,
        appName: constants_1.InternalApi.Z_USER_MANAGEMENT_APP,
        timeout: timeout ? timeout : 10000,
        custom: {
            username: "",
            password: "",
            nickname: ""
        }
    };
}, _SfuExtended_notifyMessageAttachmentState = function _SfuExtended_notifyMessageAttachmentState(attachment, state) {
    const status = {
        chatId: attachment.chatId,
        messageId: attachment.messageId,
        id: attachment.attachmentId,
        name: attachment.name,
        state: state,
        downloadedSize: attachment.payload.byteLength
    };
    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.MESSAGE_ATTACHMENT_STATE, status);
};
//# sourceMappingURL=sfu-extended.js.map